﻿@*@model IEnumerable<Web.Models.Link>*@

<header class="text-center" style="font-size:40px;color:white;">Статистика посещяемости ваших ссылок</header>
<div class="container d-flex justify-content-between" id="divStatistics">

    <canvas class="w-75 h-100" id="densityChart"></canvas>
    <div class="w-25">
        <label for="ProjectId">Выберите проект</label>
        <select class="browser-default custom-select form-control" name="ProjectId" id="selectIdProject">
            <option selected value="null">нет</option>
        </select>
        <button onclick="ShowChart()" class="btn btn-light">Построить график</button>
    </div>
</div>

@section scripts{
    <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.5.0/Chart.min.js"></script>
    <script type="text/javascript">
        function ShowChart() {
            $('#densityChart').remove();
            $('#divStatistics').prepend('<canvas class="w-75 h-100" id="densityChart"></canvas>');

            let e = document.getElementById("selectIdProject");
            let ProjectId = e.options[e.selectedIndex].value;
            let url = "@Url.Action("LinksJSON", "Link", null, "https")";
            if (ProjectId != 0)
                url += "?ProjectId=" + ProjectId;

            $.getJSON(url)
                .done(function (data){
                    var densityCanvas = document.getElementById("densityChart");

                    Chart.defaults.global.defaultFontFamily = "Lato";
                    Chart.defaults.global.defaultFontSize = 18;
                    Chart.defaults.global.defaultFontColor = '#e8e8e8';

                    var densityData = {
                        label:"Число посещений",
                        data: data.map(d => d.countClick),
                        backgroundColor: 'rgba(0, 99, 132, 0.6)'
                    };

                    var barChart = new Chart(densityCanvas, {
                        type: 'bar',
                        data: {
                            labels: data.map(d => d.name),
                            datasets: [densityData]
                        },
                            options: {
                                scales: {
                                    yAxes: [{
                                        ticks: {
                                            beginAtZero: true
                                        }
                                    }]
                                }
                            }
                    });
                });
        }
        function ProjectsSelect() {
            $.getJSON("@Url.Action("ProjectsJSON", "Project", null, "https")")
                .done(function (data) {
                    data.forEach(d => {
                        let option = document.createElement("option");
                        option.value = d.id;
                        let textnode = document.createTextNode(d.name);
                        option.appendChild(textnode);
                        document.getElementById("selectIdProject").add(option);
                    });
                });
        }

        window.onload = function () {
            ShowChart();
            ProjectsSelect();
        };
    </script>
}